image: docker

stages:
  - build

variables:
  ZULU_8_VERSION: "8.78.0.19"     # https://www.azul.com/downloads/?version=java-8-lts&os=linux&architecture=arm-64-bit&package=jdk#zulu
  JAVA_8_VERSION: "8.0.412"

  ZULU_1104_VERSION: "11.33.21"   # https://www.azul.com/downloads/?version=java-11-lts&os=linux&architecture=arm-64-bit&package=jdk&show-old-builds=true#zulu
  JAVA_1104_VERSION: "11.0.4-c2"

  ZULU_11_VERSION: "11.72.19"     # https://www.azul.com/downloads/?version=java-11-lts&os=linux&architecture=arm-64-bit&package=jdk&show-old-builds=true#zulu
  JAVA_11_VERSION: "11.0.23"

  ZULU_1704_VERSION: "17.36.17"   # https://www.azul.com/downloads/?version=java-17-lts&os=linux&architecture=arm-64-bit&package=jdk&show-old-builds=true#zulu
  JAVA_1704_VERSION: "17.0.4.1"

  ZULU_17_VERSION: "17.50.19"     # https://www.azul.com/downloads/?version=java-17-lts&os=linux&architecture=arm-64-bit&package=jdk&show-old-builds=true#zulu
  JAVA_17_VERSION: "17.0.11"

  ZULU_21_VERSION: "21.34.19"     # https://www.azul.com/downloads/?version=java-21-lts&os=linux&architecture=arm-64-bit&package=jdk&show-old-builds=true#zulu
  JAVA_21_VERSION: "21.0.3"

  ZULU_22_VERSION: "22.30.13"     # https://www.azul.com/downloads/?version=java-22-lts&os=linux&architecture=arm-64-bit&package=jdk&show-old-builds=true#zulu
  JAVA_22_VERSION: "22.0.1"

build:java8-stretch:
  stage: build
  when: manual
  tags:
    - arm64-onprem-public
  variables:
    DEB_VERSION: "stretch"
    PARENT_IMAGE: "debian:stretch-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_8_VERSION}"
    - export JAVA_VERSION="${JAVA_8_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian.stretch .
    - docker push -a $CI_REGISTRY_IMAGE
    
build:java11-stretch:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "stretch"
    PARENT_IMAGE: "debian:stretch-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_11_VERSION}"
    - export JAVA_VERSION="${JAVA_11_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian.stretch .
    - docker push -a $CI_REGISTRY_IMAGE

build:java8-buster:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "buster"
    PARENT_IMAGE: "debian:buster-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_8_VERSION}"
    - export JAVA_VERSION="${JAVA_8_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java11-buster:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "buster"
    PARENT_IMAGE: "debian:buster-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_11_VERSION}"
    - export JAVA_VERSION="${JAVA_11_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java1704-buster:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "buster"
    PARENT_IMAGE: "debian:buster-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_1704_VERSION}"
    - export JAVA_VERSION="${JAVA_1704_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java1104-buster:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "buster"
    PARENT_IMAGE: "debian:buster-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_1104_VERSION}"
    - export JAVA_VERSION="${JAVA_1104_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java8-bionic:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "bionic"
    PARENT_IMAGE: "ubuntu:bionic"
  before_script:
    - export ZULU_VERSION="${ZULU_8_VERSION}"
    - export JAVA_VERSION="${JAVA_8_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java11-bionic:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "bionic"
    PARENT_IMAGE: "ubuntu:bionic"
  before_script:
    - export ZULU_VERSION="${ZULU_11_VERSION}"
    - export JAVA_VERSION="${JAVA_11_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java17-bionic:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "bionic"
    PARENT_IMAGE: "ubuntu:bionic"
  before_script:
    - export ZULU_VERSION="${ZULU_17_VERSION}"
    - export JAVA_VERSION="${JAVA_17_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java17-focal:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "focal"
    PARENT_IMAGE: "ubuntu:focal"
  before_script:
    - export ZULU_VERSION="${ZULU_17_VERSION}"
    - export JAVA_VERSION="${JAVA_17_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java17-buster:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "buster"
    PARENT_IMAGE: "debian:buster-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_17_VERSION}"
    - export JAVA_VERSION="${JAVA_17_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java17-bookworm:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "bookworm"
    PARENT_IMAGE: "debian:bookworm-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_17_VERSION}"
    - export JAVA_VERSION="${JAVA_17_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java21-bullseye:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "buster"
    PARENT_IMAGE: "debian:bullseye-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_21_VERSION}"
    - export JAVA_VERSION="${JAVA_21_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE

build:java22-bullseye:
  stage: build
  when: manual
  tags:
  - arm64-onprem-public
  variables:
    DEB_VERSION: "buster"
    PARENT_IMAGE: "debian:bullseye-slim"
  before_script:
    - export ZULU_VERSION="${ZULU_22_VERSION}"
    - export JAVA_VERSION="${JAVA_22_VERSION}"
    - export MAJOR_VERSION=`echo $JAVA_VERSION | cut -d. -f1`
    - export ZULU_DOWNLOAD_URL=https://cdn.azul.com/zulu/bin/zulu$ZULU_VERSION-ca-jdk$JAVA_VERSION-linux_aarch64.tar.gz
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - DOCKER_CONTENT_TRUST=1 DOCKER_BUILDKIT=1 docker build --squash --build-arg MAJOR_VERSION=$MAJOR_VERSION --build-arg ZULU_VERSION=$ZULU_VERSION --build-arg JAVA_VERSION=$JAVA_VERSION --build-arg PARENT_IMAGE=$PARENT_IMAGE --build-arg ZULU_DOWNLOAD_URL=$ZULU_DOWNLOAD_URL -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$JAVA_VERSION -t $CI_REGISTRY_IMAGE:$DEB_VERSION-$MAJOR_VERSION -f ./Dockerfile.debian .
    - docker push -a $CI_REGISTRY_IMAGE